/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __CONTROLLERS_PROPERTIES_H__
#define __CONTROLLERS_PROPERTIES_H__

#include <qdialog.h>

class QListBox;
class QComboBox;
class QWidgetStack;

class Pattern;
class Controller;

/**
 * @short Controller Properties editor (per pattern)
 */
class ControllersProperties:public QDialog{
  Q_OBJECT
 protected:
  QListBox *controllerList;
  QComboBox *controllerTypeCombo;
  QWidgetStack *wstack;

  QComboBox *controllerCombo;

  QComboBox *sysExCombo;
  QComboBox *sysExParamCombo;

  Pattern *pattern;

 public:
  ControllersProperties(Pattern *_pattern,QWidget *parent, const char *name);

 signals:
  void showSysExEditor();
  void addController(Controller *);

 public slots:
  void addControllerSlot();
  void insertedController(int nc);
  void selectedController(int nc); 
  void delControllerSlot();
  void deletedController(const QString &name);
  void changeController();
  void delSysExParam(const QString &name, int paramn);
  void delSysEx(const QString &name);
  void selectedSysEx(int nc); 
  void newSysExController(const QString &name);
  void newSysExParam(const QString &sysexname, const QString &paramname);
  void changedController(unsigned int controllerId);
};

#endif
