/***************************************************************************
 *   Copyright (C) 2003 by David Moreno Montero                            *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __KMTFILE_H__
#define __KMTFILE_H__

#include <qstring.h>

class kmiditrackerView;
class QDomDocument;
class QDomElement;
class Track;
class Pattern;

/**
 * @short Just a punctual class to save data to a file, and load it.
 */
class KMTFile{
 public:
  KMTFile(const QString &filename, kmiditrackerView *view);
  ~KMTFile();

  int save();
  int load();
 private:
  QDomElement elementTrack(Track *tr,int id);
  QDomElement elementPattern(Pattern *tr,int id);
  QDomElement elementSessionData();

  void readSession(const QDomElement &);
  Track *readTrack(const QDomElement &);
  Pattern *readPattern(const QDomElement &);

  /// Filename to save/load
  QString filename;
  /// The associated view, from this view we get/set all data
  kmiditrackerView *view;
  /// Dom Document, to save/load XML
  QDomDocument *doc;
};

#endif
