/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __KSBFILE_H__
#define __KSBFILE_H__

#include <qstring.h>

class SysExBag;
class QDomDocument;
class QDomElement;
class SysEx;

/**
 * @short KMidiTracker SysEx Bag file
 *
 * Used to load and save sysex bags.
 */
class KSBFile{
 public:
  KSBFile(const QString &filename, SysExBag *bag);
  KSBFile(QDomDocument *doc, SysExBag *bag);
  ~KSBFile();

  int load();
  void loadData(QDomElement &root);
  int save();
  QDomElement saveData(const QString &tagname="kmtsysexbag");
  int import();

  QDomElement createSysEx(SysEx *);
 protected:

  SysEx *readSysEx(const QDomElement &);

  QString filename;
  QDomDocument *doc;
  SysExBag *sysexbag;
};

#endif
