/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/


#ifndef __MIDICONTROLLER_H__
#define __MIDICONTROLLER_H__

#include <qstring.h>
#include "controller.h"

/**
 * @short Specialices the Controller to MidiController s
 *
 * The midi controllers are the more common kind of controllers as it
 * is a Standard MIDI message.
 * 
 * Extra data contained is the controllerId. Type is 1.
 */
class MidiController : public Controller{
 protected:
  /// The MIDI controller Identification
  int controllerId;
  /// Last sent vlue, to do not send again (unless it is the first position of array)
  float lastvalue;

 public:
  MidiController(int controllerId, MidiOut *out, unsigned int size=64);
  MidiController(Controller *c, int controllerId);

  void step(int step);

  /// Returns the controllerId of this controller
  int getControllerId(){ return controllerId; }
  /// Sets the controller Id of this controller
  void setControllerId(int _controllerId){ controllerId=_controllerId; emit textChanged(); }
  /// Just returns the controller Id. It is 1.
  int controllerType(){ return 1; };
  QString getText();
  static QString controllerName(int n);
};

#endif
