/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include "pattern.h"

/**
 * @short Initializes some data from the selected Pattern pt
 *
 * It initializes the fileds of the pattern prop with these data from
 * the pattern... name, rows, cols, controllers...
 */
void PatternProp::init(Pattern *pt){
    rowsCombo->setEditText(QString("%1").arg(pt->getRows()));
    columnsSpin->setValue(pt->getCols());
    nameEdit->setText(pt->name());
}

/**
 * @short Emits several signals about rows, cols and name
 */
void PatternProp::okPressed()
{
    emit setRows(rowsCombo->currentText().toUInt());
    emit setCols(columnsSpin->value());
    emit setName(nameEdit->text());
}

/**
 * @short The pattern name changed to name
 */
void PatternProp::changePatternName( const QString &name)
{
    nameEdit->setName(name);
}


void PatternProp::showControllerPropertiesSlot()
{
    emit showControllerProperties();
}
