/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/


#ifndef __PITCH_CONTROLLER_H__
#define __PITCH_CONTROLLER_H__

#include "controller.h"


class PitchController:public Controller{
 protected:
  float lastvalue;

 public:
  PitchController(MidiOut *out, unsigned int size):Controller(out,size){
    minimum=-8192;
    maximum=8192;
    bigstep=128;
    lastvalue=-2.0;
  };
  PitchController(Controller *c):Controller(c){
    minimum=-8192;
    maximum=8192;
    bigstep=128;
    lastvalue=-2.0;
  };

  void step(int step);
  int controllerType(){ return 3; }
  QString getText(){ return "Pitch Bend"; }
};

#endif
