/*
 * Copyright (C) 2004 David Moreno Montero <david@monasteriomono.org>
 */

#ifndef _KMIDITRACKERPREF_H_
#define _KMIDITRACKERPREF_H_

#include <kconfigdialog.h>
#include <qframe.h>

class QLabel;
class QSlider;
class QCheckBox;

class kmiditrackerPrefPageOne;
class kmiditrackerPrefPageTwo;

class kmiditrackerPreferences : public KConfigDialog
{
    Q_OBJECT
public:
    kmiditrackerPreferences();

public slots:
  void settingsChangedSlot();
private:
    kmiditrackerPrefPageOne *m_pageOne;
    kmiditrackerPrefPageTwo *m_pageTwo;
};

class kmiditrackerPrefPageOne : public QFrame
{
    Q_OBJECT
public:
    kmiditrackerPrefPageOne(QWidget *parent = 0);
private slots:
    void MTCOffsetChanged(int);
 
public slots:
  void saveChanges();
signals:
    void configChanged();
private:
  QSlider *MTCOffset;
  QLabel *MTCLabel;
  QCheckBox *MidiThru;
  QCheckBox *SendMidiClock;
  
};

class kmiditrackerPrefPageTwo : public QFrame
{
    Q_OBJECT
public:
  kmiditrackerPrefPageTwo(QWidget *parent = 0);
public slots:
  void saveChanges();
signals:
  void configChanged();
private:
  QCheckBox *hp;
  QCheckBox *rtc;
  QCheckBox *rt;
};

#endif // _KMIDITRACKERPREF_H_
