/***************************************************************************
 *   Copyright (C) 2004 by David Moreno Montero                            *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __SIGNATURE_WIDGET_H__
#define __SIGNATURE_WIDGET_H__

#include <qhbox.h>
#include <qlabel.h>
#include <qspinbox.h>


class SignatureWidget:public QHBox{
  Q_OBJECT
public:
  SignatureWidget(int a, int b, QObject *parent, const char *name){
    new QLabel("Signature",this);
    beatLength=new QSpinBox(1,100,1,this,"beat_length");
    beatLength->setValue(a);
    connect(beatLength,SIGNAL(valueChanged(int)),this,SLOT(setBeatLength(int)));
    new QLabel("/",this);
    beatsPerBar=new QSpinBox(1,100,1,this,"beat_length");
    beatsPerBar->setValue(b);
    connect(beatsPerBar,SIGNAL(valueChanged(int)),this,SLOT(setBeatsPerBar(int)));
  };

  signals:
  void newSignature(int,int);

 public slots:
 void updateSignature(int a,int b){ beatLength->setValue(a); beatsPerBar->setValue(b); }
 void setBeatLength(int a){ emit newSignature(a, beatsPerBar->value()); }
 void setBeatsPerBar(int a){ emit newSignature(beatLength->value(),a); }
protected:
  QSpinBox *beatLength;
  QSpinBox *beatsPerBar;
};


#endif
