/***************************************************************************
 *   Copyright (C) 2003 by David Moreno Montero                            *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __SMFFILE_H__
#define __SMFFILE_H__

#include <qstring.h>
#include <qvaluelist.h>

class kmiditrackerView;
class Track;
class Pattern;
class QFile;

/**
 * @short Just a punctual class to save data to a file, and load it.
 */
class SMFFile{
 public:
  SMFFile(const QString &filename, kmiditrackerView *view);
  ~SMFFile();

  int save();
  int load();
 private:
  /// Filename to save/load
  QString filename;
  /// The associated view, from this view we get/set all data
  kmiditrackerView *view;
  /// The current time step
  unsigned int step;
  /// Last played note per channel
  unsigned char lastNote[256];


  void saveTrack(Track *, QFile &);
  void savePattern(Pattern *, QValueList<char> &data, int pstep);
  void saveTime(QValueList<char> &data, unsigned long time);
};

#endif
