/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __SYSEXCONTROLLER_H__
#define __SYSEXCONTROLLER_H__

#include "controller.h"

class SysEx;


/**
 * @short Controller specialized in sysex messages
 *
 * This controller can change small parts of a sysex message, and send
 * it.
 */
class SysExController : public Controller{
  Q_OBJECT
 protected:
  /// Sysex message
  SysEx *sysex;
  /// Number of parameter
  int paramn;

  /// Last value, used to check if I should send a message again now
  float lastvalue;
 public:
  SysExController(SysEx *sysex, int nparm, MidiOut *out, unsigned int size);
  SysExController(Controller *c, SysEx *sysex, int nparam);

  void step(int step);
  int controllerType(){ return 2; };
  void changeSysEx(SysEx *nsysex, int nparam=0);
  QString getText();
  SysEx *getSysEx(){ return sysex; };
  int getParamNumber(){ return paramn; };

 public slots:
  void delSysExParam(const QString &name, int paramn);
};


#endif
