/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __SYSEX_EDITOR_H__
#define __SYSEX_EDITOR_H__

#include <kdialog.h>
#include <qptrlist.h>
#include <qstringlist.h>

#include "sysex.h"
#include "sysexbag.h"

class QComboBox;
class QTextEdit;
class QVBox;
class QHBox;


/**
 * @short Dialog usefull to edit SysEx Messages
 */
class SysExEditor: public KDialog{
  Q_OBJECT
protected:
  SysExBag *sysex;
  SysEx *actualSysEx;
  QComboBox *nameCombo;
  QTextEdit *message;
  QComboBox *controllerCombo;
  QStringList sysExNames;
  QVBox *edit;
  QHBox *editName;

public:
  SysExEditor(SysExBag *sysexbag, QWidget *parent);

  SysExBag *getSysEx(){ return sysex; };
  SysEx *getSysEx(int n){ return sysex->at(n); };
  int sysExCount(){ return sysex->count(); };

public slots:
  void newSysEx();
  void newController(); 
  void newSysEx(const char *name);
  void addSysEx(const QString &name);
  void newController(const char *name); 
  void delController(const QString &name, int param);
  void delSysEx();
  void delController(); 
  void deletedSysEx(const QString &name);

  void enterNewMessage(const QString &initial);
  void enterNewMessage();
  void loadNewMessage();
  void loadNewMessageFromUnnamed();

  void selectedController(int);

  void setActualSysEx(const QString &name);
  void setSysExMessage(const char *data, int count);
  void setSysExMessageHex(const QString &text);
};

#endif
