/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#include "verticallabel.h"
#include "verticaltextitem.h"

VerticalLabel::VerticalLabel(const QString &_text, QWidget *parent, const char *name):
  QWidget(parent, name){
  text=_text;

  setMinimumSize(minimumSizeHint());
}

VerticalLabel::~VerticalLabel(){
}


void VerticalLabel::setText(const QString &t){
  text=t;
  update();
}

QSizePolicy VerticalLabel::sizePolicy() const{
    return QSizePolicy( QSizePolicy::Fixed, QSizePolicy::Expanding );
}


void VerticalLabel::paintEvent (QPaintEvent *pe){
  QPainter p(this);

  p.save();
  
  p.setFont(QFont());
  p.setPen(foregroundColor());
  
  p.rotate(90);
  p.translate(-x(), -y());
  p.translate(y(), -x());
  
  p.drawText(2,-4,text);
  p.restore();
}


QSize VerticalLabel::minimumSizeHint(){
  return QSize(QFontMetrics(QFont()).height()+4,20);
}

