/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/


#ifndef __VERTICAL_LABEL_H__
#define __VERTICAL_LABEL_H__

#include <qwidget.h>


class VerticalLabel: public QWidget{
  Q_OBJECT
 public:
  VerticalLabel(const QString &text, QWidget *parent=0, const char *name=0);
  ~VerticalLabel();

  virtual QSize minimumSizeHint();
  virtual QSizePolicy sizePolicy() const;

 protected:
  QString text;
  virtual void paintEvent ( QPaintEvent * );
  virtual void mouseDoubleClickEvent ( QMouseEvent * ){ emit doubleClicked(); };


 signals:
  void doubleClicked();

 public slots:
  void setText(const QString &text);
};

#endif
