/***************************************************************************
 *   Copyright (C) 2004,2005 by David Moreno Montero                       *
 *   david@monasteriomono.org                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.           *
 ***************************************************************************/

#ifndef __VERTICAL_TEXT_ITEM_H__
#define __VERTICAL_TEXT_ITEM_H__

#include <qcanvas.h>
#include <qstring.h>
#include <qpainter.h>

/**
 * @short Simple rotated text class
 *
 * Example from http://lists.trolltech.com/qt-interest/2001-02/thread00700-0.html 
 */
class VerticalText : public QCanvasText {
public:
  VerticalText(const QString &text, QCanvas *canvas) :
    QCanvasText(text, canvas) {};
  virtual QRect boundingRect(){
    QRect r=QCanvasText::boundingRect();
    return QRect(r.x()-r.height(),r.y(), r.height(), r.width());
  }
  
protected:
  void draw(QPainter &p)
  {
    //    p.setBrush(Qt::NoBrush);
    //p.drawRect(boundingRect());
    p.save();
    
    p.rotate(90);
    p.translate(-x(), -y());
    p.translate(y(), -x());
    
    // Have the base class draw it
    QCanvasText::draw(p);

    p.restore();
  }
};


#endif
